Loading...
Searching...
No Matches
casacore::LCExtension Class Reference
lattices package (libcasa_lattices) » LRegions_module

More...

`#include <LCExtension.h>`

## Public Member Functions

| LCExtension ()
| LCExtension (const LCRegion &region, const IPosition &extendAxes, const LCBox &extendBox)
| Extend the given region along axes as given by extendAxes from the bottom left corner (blc) to the top right corner (trc) as given by extendBox.
| LCExtension (Bool takeOver, const LCRegion *region, const IPosition &extendAxes, const LCBox &extendBox)
| LCExtension (const LCExtension &other)
| Copy constructor (copy semantics).
virtual | ~LCExtension ()
LCExtension & | operator= (const LCExtension &other)
| Assignment (copy semantics).
virtual Bool | operator== (const LCRegion &other) const
| Comparison.
virtual LCRegion * | cloneRegion () const
| Make a copy of the derived object.
const LCRegion & | region () const
| Get the original region.
const IPosition & | extendAxes () const
| Get the extend axes.
const LCBox & | extendBox () const
| Get the extend box.
virtual String | type () const
| Get the region type.
virtual TableRecord | toRecord (const String &tableName) const
| Convert the (derived) object to a record.
Public Member Functions inherited from casacore::LCRegionMulti
| LCRegionMulti ()
| LCRegionMulti (const LCRegion &region1, const LCRegion &region2)
| Construct from 2 regions.
| LCRegionMulti (Bool takeOver, const LCRegion *region1, const LCRegion *region2=0, const LCRegion *region3=0, const LCRegion *region4=0, const LCRegion *region5=0, const LCRegion *region6=0, const LCRegion *region7=0, const LCRegion *region8=0, const LCRegion *region9=0, const LCRegion *region10=0)
| Construct from multiple regions.
| LCRegionMulti (Bool takeOver, const PtrBlock< const LCRegion * > &regions)
| Construct from multiple regions given as a Block.
| LCRegionMulti (const LCRegionMulti &other)
| Copy constructor (copy semantics).
virtual | ~LCRegionMulti ()
LCRegionMulti & | operator= (const LCRegionMulti &other)
| Assignment (copy semantics).
virtual Bool | hasMask () const
| Does the region have a mask?
Public Member Functions inherited from casacore::LCRegion
| LCRegion ()
| LCRegion (const IPosition &latticeShape)
| Construct with the lattice shape only.
| LCRegion (const LCRegion &other)
| Copy constructor (copy semantics).
virtual | ~LCRegion ()
Bool | operator!= (const LCRegion &other) const
| Non-equality.
virtual Lattice< Bool > * | clone () const
| Make a copy of the derived object.
virtual void | handleDelete ()
| Handle deletion of the region by deleting possible tables.
virtual void | handleRename (const String &newName, Bool overwrite)
| Handle renaming the region by renaming possible tables.
const String & | comment () const
| Get or set the comment.
void | setComment (const String &comment)
LCRegion * | translate (const IPosition &translateVector) const
| Construct another LCRegion (for e.g.
LCRegion * | translate (const IPosition &translateVector, const IPosition &newLatticeShape) const
LCRegion * | translate (const Vector< Float > &translateVector) const
LCRegion * | translate (const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
const IPosition & | latticeShape () const
| Give the full lattice shape.
const Slicer & | boundingBox () const
| Give the bounding box.
Slicer | expand (const Slicer &slicer) const
| Expand a slicer or position in the region to the full lattice.
IPosition | expand (const IPosition &index) const
virtual uInt | ndim () const
| Return the dimensionality of the region.
virtual IPosition | shape () const
| Return the shape of the region (i.e.
virtual Bool | isWritable () const
| Usually the lattice (i.e.
virtual void | doPutSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Regions can usually not be put; i.e.
virtual void | set (const Bool &value)
| Set all elements in the Lattice to the given value.
virtual void | apply (Bool(*function)(Bool))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (Bool(*function)(const Bool &))
virtual void | apply (const Functional< Bool, Bool > &function)
virtual void | putAt (const Bool &value, const IPosition &where)
| Put the value of a single element.
virtual void | copyData (const Lattice< Bool > &from)
| Copy the data from the given lattice to this one.
Public Member Functions inherited from casacore::Lattice< Bool >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
Bool | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual Bool | getAt (const IPosition &where) const
Bool | get (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | put (const Array< Bool > &sourceBuffer)
void | operator+= (const Lattice< Bool > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< Bool > &other)
void | operator*= (const Lattice< Bool > &other)
void | operator/= (const Lattice< Bool > &other)
virtual void | copyDataTo (Lattice< Bool > &to) const
| Copy the data from this lattice to the given lattice.
virtual uInt | advisedMaxPixels () const
| This function returns the advised maximum number of pixels to include in the cursor of an iterator.
virtual LatticeIterInterface< Bool > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| These functions are used by the LatticeIterator class to generate an iterator of the correct type for a specified Lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| It is strongly recommended to use class LatticeLocker to handle lattice locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
virtual String | name (Bool stripPath=False) const
| Return the name of the current Lattice object.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual Bool | ok () const
| Check class internals - used for debugging.
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Static Public Member Functions

static String | className ()
| Get the class name (to store in the record).
static LCExtension * | fromRecord (const TableRecord &, const String &tableName)
| Convert correct object from a record.
Static Public Member Functions inherited from casacore::LCRegion
static LCRegion * | fromRecord (const TableRecord &, const String &tableName)
| Convert correct object from a record.

## Protected Member Functions

virtual LCRegion * | doTranslate (const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
| Construct another LCRegion (for e.g.
virtual void | multiGetSlice (Array< Bool > &buffer, const Slicer &section)
| Do the actual getting of the mask.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| This function is needed here because the niceCursorShape of the contributing region does not make any sense (other dimensionality).
Protected Member Functions inherited from casacore::LCRegionMulti
TableRecord | makeRecord (const String &tableName) const
| Store the contributing regions in a record.
void | multiTranslate (PtrBlock< const LCRegion * > &, const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
| Translate all regions.
void | fillHasMask ()
| Determine if all regions have mask (used by LCIntersection).
Bool | findAreas (IPosition &bufStart, IPosition &bufEnd, IPosition &regStart, IPosition &regEnd, const Slicer &section, uInt regNr) const
| Find which area of the section and region are needed.
const PtrBlock< const LCRegion * > & | regions () const
| Get the contributing regions.
| LCRegionMulti (const LCRegion *region, const IPosition &latticeShape)
| Construct from lattice shape and region pointer, which is taken over.
virtual Bool | doGetSlice (Array< Bool > &buffer, const Slicer &section)
| Do the actual getting of an array of values.
Protected Member Functions inherited from casacore::LCRegion
LCRegion & | operator= (const LCRegion &other)
| Assignment (copy semantics) is only useful for derived classes.
void | setBoundingBox (const Slicer &boundingBox)
| Sometimes it is inconvenient for a derived class to set the bounding box in the constructor.
void | setShapeAndBoundingBox (const IPosition &latticeShape, const Slicer &boundingBox)
void | defineRecordFields (RecordInterface &record, const String &className) const
| Define the type and class name in the record.
Protected Member Functions inherited from casacore::Lattice< Bool >
void | handleMathTo (Lattice< Bool > &, int) const
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< Bool > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
Lattice< Bool > & | operator= (const Lattice< Bool > &)
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Private Member Functions

void | fillRegionAxes ()
| Fill the object.
void | fill (const IPosition &stretchAxes, const LCBox &stretchBox)

## Private Attributes

IPosition | itsExtendAxes
IPosition | itsRegionAxes
LCBox | itsExtendBox

## Additional Inherited Members

Static Protected Member Functions inherited from casacore::LCRegionMulti
static void | unmakeRecord (PtrBlock< const LCRegion * > &, const TableRecord &, const String &tableName)
| Retrieve the contributing objects from the record.

## Detailed Description

Extend an LCRegion along straight lines to other dimensions

### Intended use:

Public interface

### Prerequisite

- LCRegion

### Synopsis

The LCExtension class is a specialization of class LCRegion. It makes it possible to extend a LCRegion along straight lines to other dimensions. E.g. a circle in the xy-plane can be extended to a cylinder in the xyz-space. It can be used for a lattice of any dimensionality as long as the dimensionality of the (hyper-)extension matches the dimensionality of the lattice.

### Example

### To Do

- Extend along (slanted) cone lines

Definition at line 70 of file LCExtension.h.

## Constructor & Destructor Documentation

## LCExtension() [1/4]

casacore::LCExtension::LCExtension | ( |  | ) |

Referenced by fromRecord(), LCExtension(), and operator=().

## LCExtension() [2/4]

casacore::LCExtension::LCExtension | ( | const LCRegion & | region,
|  | const IPosition & | extendAxes,
|  | const LCBox & | extendBox )

Extend the given region along axes as given by extendAxes from the bottom left corner (blc) to the top right corner (trc) as given by extendBox.

Every kind of box (absolute, relative, fractional, unspecified) can be used to define the extension blc and trc. The sum of the dimensionality of the region and the extend box make up the dimensionality of the LCExtension region. Similarly the lattice shapes in region and box are combined.
The second version takes over the pointer when the switch is true.

References extendAxes(), extendBox(), and region().

## LCExtension() [3/4]

casacore::LCExtension::LCExtension | ( | Bool | takeOver,
|  | const LCRegion * | region,
|  | const IPosition & | extendAxes,
|  | const LCBox & | extendBox )

References extendAxes(), extendBox(), and region().

## LCExtension() [4/4]

casacore::LCExtension::LCExtension | ( | const LCExtension & | other | ) |

Copy constructor (copy semantics).

References LCExtension().

## ~LCExtension()

virtual casacore::LCExtension::~LCExtension | ( |  | ) |

virtual

## Member Function Documentation

## className()

String casacore::LCExtension::className | ( |  | ) |

static

Get the class name (to store in the record).

## cloneRegion()

virtual LCRegion * casacore::LCExtension::cloneRegion | ( |  | ) | const

virtual

Make a copy of the derived object.

Implements casacore::LCRegion.

## doNiceCursorShape()

virtual IPosition casacore::LCExtension::doNiceCursorShape | ( | uInt | maxPixels | ) | const

protected virtual

This function is needed here because the niceCursorShape of the contributing region does not make any sense (other dimensionality).

Reimplemented from casacore::LCRegionMulti.

## doTranslate()

virtual LCRegion * casacore::LCExtension::doTranslate | ( | const Vector< Float > & | translateVector,
|  | const IPosition & | newLatticeShape ) const

protected virtual

Construct another LCRegion (for e.g.

another lattice) by moving this one. It recalculates the bounding box and mask. A positive translation value indicates "to right".

Implements casacore::LCRegion.

## extendAxes()

const IPosition & casacore::LCExtension::extendAxes | ( |  | ) | const

inline

Get the extend axes.

Definition at line 162 of file LCExtension.h.

References itsExtendAxes.

Referenced by LCExtension(), and LCExtension().

## extendBox()

const LCBox & casacore::LCExtension::extendBox | ( |  | ) | const

inline

Get the extend box.

Definition at line 166 of file LCExtension.h.

References itsExtendBox.

Referenced by LCExtension(), and LCExtension().

## fill()

void casacore::LCExtension::fill | ( | const IPosition & | stretchAxes,
|  | const LCBox & | stretchBox )

private

## fillRegionAxes()

void casacore::LCExtension::fillRegionAxes | ( |  | ) |

private

Fill the object.

## fromRecord()

LCExtension * casacore::LCExtension::fromRecord | ( | const TableRecord & | ,
|  | const String & | tableName )

static

Convert correct object from a record.

References LCExtension().

## multiGetSlice()

virtual void casacore::LCExtension::multiGetSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section )

protected virtual

Do the actual getting of the mask.

Implements casacore::LCRegionMulti.

## operator=()

LCExtension & casacore::LCExtension::operator= | ( | const LCExtension & | other | ) |

Assignment (copy semantics).

References LCExtension().

## operator==()

virtual Bool casacore::LCExtension::operator== | ( | const LCRegion & | other | ) | const

virtual

Comparison.

Reimplemented from casacore::LCRegionMulti.

## region()

const LCRegion & casacore::LCExtension::region | ( |  | ) | const

inline

Get the original region.

Definition at line 158 of file LCExtension.h.

References casacore::LCRegionMulti::regions().

Referenced by LCExtension(), and LCExtension().

## toRecord()

virtual TableRecord casacore::LCExtension::toRecord | ( | const String & | tableName | ) | const

virtual

Convert the (derived) object to a record.

Implements casacore::LCRegion.

## type()

virtual String casacore::LCExtension::type | ( |  | ) | const

virtual

Get the region type.

Returns the class name.

Implements casacore::LCRegion.

## Member Data Documentation

## itsExtendAxes

IPosition casacore::LCExtension::itsExtendAxes

private

Definition at line 152 of file LCExtension.h.

Referenced by extendAxes().

## itsExtendBox

LCBox casacore::LCExtension::itsExtendBox

private

Definition at line 154 of file LCExtension.h.

Referenced by extendBox().

## itsRegionAxes

IPosition casacore::LCExtension::itsRegionAxes

private

Definition at line 153 of file LCExtension.h.

The documentation for this class was generated from the following file:

- lattices/LRegions/LCExtension.h